<?php
/**
 *
 * @link              https://modeltheme.com
 * @since             1.0.0
 * @package           Ride_Sharing_Affiliate_Forms
 *
 * @wordpress-plugin
 * Plugin Name:       Ride Sharing Affiliate Forms
 * Plugin URI:        https://plugins.modeltheme.com/ride-sharing-affiliate-forms
 * Description:       Boost your affiliate marketing efforts, drive more sign-ups, and enhance your ride-sharing business's online presence.
 * Version:           1.0.0
 * Author:            Modeltheme
 * Author URI:        https://modeltheme.com/
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       ride-sharing
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

//WPBakery widgets
require_once( __DIR__ . '/shortcodes/ride-sharing-builder.php' );


//Elementor Widgets
if ( class_exists('Elementor\Core\Admin\Admin') ) {
    require_once('shortcodes/elementor/functions.php');
}

function ride_sharing_affiliate_forms_styles() {
    //CSS
    wp_enqueue_style( 'ride-sharing-affiliate', plugins_url( 'assets/css/ride-sharing-affiliate.css', __FILE__ ), array(), '1.0.0', 'all' );
    wp_enqueue_style( 'jquery-ui', plugins_url( 'assets/css/jquery-ui.css', __FILE__ ), array(), '1.0.0', 'all' );
    //SCRIPTS
    wp_enqueue_script( 'ride-sharing-affiliate', plugins_url( 'assets/js/ride-sharing-affiliate.js', __FILE__ ), array('jquery'), '1.0.0', true );
    wp_enqueue_script( 'jquery-ui-datepicker', plugins_url( 'assets/js/datepicker.min.js', __FILE__ ), array('jquery'), '1.0.0', true );
}
add_action( 'wp_enqueue_scripts', 'ride_sharing_affiliate_forms_styles' );


/**
||-> Function: LOAD PLUGIN TEXTDOMAIN
*/
function ride_sharing_affiliate_load_textdomain(){
    $domain = 'ride-sharing';
    $locale = apply_filters( 'plugin_locale', get_locale(), $domain );

    load_textdomain( $domain, trailingslashit( WP_LANG_DIR ) . $domain . '/' . $domain . '-' . $locale . '.mo' );
    load_plugin_textdomain( $domain, FALSE, basename( plugin_dir_path( dirname( __FILE__ ) ) ) . '/languages/' );
}
add_action( 'plugins_loaded', 'ride_sharing_affiliate_load_textdomain' );