<?php
class Ride_Sharing_Affiliate_Elementor_Widgets {

	protected static $instance = null;

	public static function get_instance() {
		if ( ! isset( static::$instance ) ) {
			static::$instance = new static;
		}

		return static::$instance;
	}

	protected function __construct() {
		require_once('widgets/ride-sharing-builder.php');

		add_action( 'elementor/widgets/widgets_registered', [ $this, 'register_widgets' ] );
	}

	public function register_widgets() {
		\Elementor\Plugin::instance()->widgets_manager->register_widget_type( new \Elementor\ride_sharing_affiliate_forms_widget() );
	}

}

add_action( 'init', 'ride_sharing_affiliate_elementor_init' );
function ride_sharing_affiliate_elementor_init() {
	Ride_Sharing_Affiliate_Elementor_Widgets::get_instance();
}

function ride_sharing_affiliate_widget_categories( $elements_manager ) {

	$elements_manager->add_category(
		'ride-sharing-affiliate-widgets',
		[
			'title' => esc_html__( 'Ride Sharing Affiliate Forms', 'ride-sharing' ),
			'icon' => 'fas fa-plug',
		]
	);

}
add_action( 'elementor/elements/categories_registered', 'ride_sharing_affiliate_widget_categories' );