<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly.
}

//Shortcode : Ride Sharing Affiliate Form
function ride_sharing_affiliate_form_builder($params, $content) {
    extract( shortcode_atts( 
        array(
        	'page_builder'              => '',
            'submit_button_label'        => '',
            'affiliate_form_action_url'  => '',
            'form_fields'                => '',
            'color'  				     => '',
        ), $params ) ); 
    $content = '';

    if ($page_builder == 'elementor') {
      	$form_fields = unserialize(base64_decode($form_fields));
    }else{
      	if (function_exists('vc_param_group_parse_atts')) {
        	$form_fields = vc_param_group_parse_atts($params['form_fields']);
      	}
    }
 
    $content .= '<div class="mt--iffiliate_mt_affiliate_form_builder">';
        $content .= '<form action="'.esc_url($affiliate_form_action_url).'" method="get" id="iffiliatesearch">';
            $content .= '<div class="row iffiliate-row-ride-sharing">';
                if ($form_fields) {
                    foreach($form_fields as $field){

                        #required
                        $required = '';
                        if (isset($field['required']) && !empty($field['required'])) {
                            $required = 'required';
                        }

                        #label
                        $label = '';
                        if (isset($field['label']) && !empty($field['label'])) {
                            $label = $field['label'];
                        }

                        #value
                        $value = '';
                        if (isset($field['value']) && !empty($field['value'])) {
                            $value = $field['value'];
                        }

                        #name
                        $name = '';
                        if (isset($field['name']) && !empty($field['name'])) {
                            $name = $field['name'];
                        }

                        #placeholder
                        $placeholder = '';
                        if (isset($field['placeholder']) && !empty($field['placeholder'])) {
                            $placeholder = $field['placeholder'];
                        }

                        #date_format
                        $date_format = '';
                        if (isset($field['date_format']) && !empty($field['date_format'])) {
                            $date_format = $field['date_format'];
                        }

                        // echo '<pre>' . var_export($field['required'], true) . '</pre>';
                        if ($field['field'] == 'input_text' || $field['field'] == 'input_number' || $field['field'] == 'input_hidden') {
                            
                            #field type
                            $type = 'text';
                            if($field['field'] == 'input_text'){
                                $type = 'text';
                            }elseif($field['field'] == 'input_number'){
                                $type = 'number';
                            }elseif($field['field'] == 'input_hidden'){
                                $type = 'hidden';
                            }

                            // html
                            $id = 'field_'.uniqid();
                            $content .= '<div class="col-sm-12 mt_single_builder_field mt_field--'.$field['field'].'">';
                                if (isset($field['label']) && !empty($field['label'])) {
                                    $content .= '<label for="'.$id.'">'.esc_html($label).'</label>';
                                }
                                $content .= '<input id="'.$id.'" '.$required.' type="'.$type.'" value="'.$value.'" name="'.$name.'" placeholder="'.$placeholder.'" class="form-control" />';
                            $content .= '</div>';
                        }
                    
                        if ($field['field'] == 'input_datepicker') {
                            // html
                            $id = 'field_'.uniqid();
                            $content .= '<div class="col-sm-12 mt_single_builder_field mt_field--'.$field['field'].'">';
                                if (isset($field['label']) && !empty($field['label'])) {
                                    $content .= '<label for="'.$id.'">'.esc_html($label).'</label>';
                                }
                                $content .= '<input data-date-format="'.$date_format.'" id="'.$id.'" '.$required.' type="text" value="'.$value.'" name="'.$name.'" placeholder="'.$placeholder.'" class="form-control datepicker" />';
                            $content .= '</div>';
                        }
                    
                        if ($field['field'] == 'textarea') {
                            // html
                            $id = 'field_'.uniqid();
                            $content .= '<div class="col-sm-12 mt_single_builder_field mt_field--'.$field['field'].'">';
                                if (isset($field['label']) && !empty($field['label'])) {
                                    $content .= '<label for="'.$id.'">'.esc_html($label).'</label>';
                                }
                                $content .= '<textarea id="'.$id.'" '.$required.' name="'.$name.'" placeholder="'.$placeholder.'" class="form-control">'.$value.'</textarea>';
                            $content .= '</div>';
                        }
                    }
                }
             
                $content .= '<div class="col-md-12">';
                    $content .= '<input type="submit" class="rippler rippler-default button-winona btn btn-lg tabs_button" style="background-color:'.$color.';" name="submit" name="submit" value="'.esc_attr($submit_button_label).'" />';
                $content .= '</div>';
            $content .= '</div>';
        $content .= '</form>';
    $content .= '</div>';
    return $content;
}
add_shortcode('ride-sharing-affiliate-shortcode', 'ride_sharing_affiliate_form_builder');

/**
||-> Map Shortcode in Visual Composer with: vc_map();
*/
function ride_sharing_affiliate_vc_shortcodes(){
	if ( function_exists('vc_map') ) {
	    vc_map( 
	        array(
	            "name" 		=> esc_attr__("Ride Sharing Affiliate Form Builder", 'ride-sharing'),
	            "base" 		=> "ride-sharing-affiliate-shortcode",
	            "category" 	=> esc_attr__('Ride Sharing Affiliate', 'ride-sharing'),
	            "icon" 		=> '/assets/images',
	            "params" 	=> array(
	                array(
	                    "group" 		=> esc_attr__("General Options", 'ride-sharing'),
	                    "type" 			=> "textfield",
	                    "holder" 		=> "div",
	                    "class" 		=> "",
	                    "heading"		=> esc_attr__( "Form Action url", 'ride-sharing' ),
	                    "param_name" 	=> "affiliate_form_action_url",
	                    "value" 		=> "",
	                    "description" 	=> esc_attr__( "Example: https://www.blablacar.ro/search?", 'ride-sharing' )
	                ),
	                array(
	                    "group"        	=> esc_attr__("General Options", 'ride-sharing'),
	                    "type"         	=> "textfield",
	                    "holder"       	=> "div",
	                    "class"        	=> "",
	                    "param_name"   	=> "submit_button_label",
	                    "heading"      	=> esc_attr__("Submit Button label", 'ride-sharing'),
	                    "description"  	=> esc_attr__("Enter Submit button label", 'ride-sharing'),
	                ),
	                array(
	                    "group" 		=> esc_attr__("General Options", 'ride-sharing'),
	                    "type" 			=> "colorpicker",
	                    "class" 		=> "",
	                    "heading" 		=> esc_attr__( "Choose custom background color" , 'ride-sharing'),
	                    "param_name" 	=> "color",
	                    "value" 		=> '#2EB875', //Default color #2EB875
	                    "description" 	=> esc_attr__( "Choose background color", 'ride-sharing' ),
	                 ),
	                array(
	                    "group"        	=> esc_attr__( "Form Fields Builder", 'ride-sharing' ),
	                    'type'		 	=> 'param_group',
	                    'value' 		=> '',
	                    'param_name' 	=> 'form_fields',
	                    // Note params is mapped inside param-group:
	                    'params' 		=> array(
	                        array(
	                            'type' 			=> 'dropdown',
	                            'heading' 		=> esc_html__( 'Field Type', 'ride-sharing' ),
	                            'value' 		=> array(
		                                esc_html__( 'Input text', 'ride-sharing' ) => 'input_text',
		                                esc_html__( 'Input number', 'ride-sharing' ) => 'input_number',
		                                esc_html__( 'Input hidden', 'ride-sharing' ) => 'input_hidden',
		                                esc_html__( 'Input datepicker', 'ride-sharing' ) => 'input_datepicker',
		                                esc_html__( 'Textarea', 'ride-sharing' ) => 'textarea',
	                            ),
	                            'admin_label'	 => true,
	                            'param_name' 	 => 'field',
	                            'description' 	 => esc_html__( 'Select icon library.', 'ride-sharing' ),
	                        ),
	                        array(
	                            'type' 			=> 'textfield',
	                            'value' 		=> '',
	                            'heading' 		=> 'Label',
	                            'param_name'	=> 'label',
	                            'description' 	=> esc_html__( 'Placeholder for the current field: Eg: "Where You From"', 'ride-sharing' ),
	                        ),
	                        array(
	                            'type' 			=> 'textfield',
	                            'value' 		=> '',
	                            'heading' 		=> esc_html__( 'Placeholder', 'ride-sharing' ),
	                            'param_name' 	=> 'placeholder',
	                            'description' 	=> esc_html__( 'Placeholder for the current field: Eg: "Departure"', 'ride-sharing' ),
	                        ),
	                        array(
	                            'type' 			=> 'textfield',
	                            'value' 		=> '',
	                            'heading' 		=> esc_html__( 'Name', 'ride-sharing' ),
	                            'param_name' 	=> 'name',
	                            'description' 	=> esc_html__( 'Placeholder for the current field: Eg: "departure"', 'ride-sharing' ),
	                        ),
	                        array(
	                            'type' 			=> 'textfield',
	                            'value' 		=> '',
	                            'heading' 		=> esc_html__( 'Value', 'ride-sharing' ),
	                            'param_name' 	=> 'value',
	                            'description' 	=> esc_html__( 'Placeholder for the current field: Eg: "Bucharest"', 'ride-sharing' ),
	                        ),
	                        array(
	                            'type' 			=> 'textfield',
	                            'value' 		=> '',
	                            'heading' 		=> esc_html__( 'Date Format', 'ride-sharing' ),
	                            'param_name' 	=> 'date_format',
	                            'description' 	=> esc_html__( 'Set a date format (Read more at: <a target="_blank" href="https://jqueryui.com/datepicker/#date-formats">Date formats docs</a>)', 'ride-sharing' ),
	                            'dependency' 	=> array(
	                                	'element' 		=> 'field',
	                                	'value' 		=> 'input_datepicker',
	                            ),
	                        ),
	                        array(
	                            'type' 			=> 'checkbox',
	                            'value' 		=> '',
	                            'heading' 		=> esc_html__( 'Required?', 'ride-sharing' ),
	                            'param_name' 	=> 'required',
	                            'description' 	=> esc_html__( 'Set if the field will be required or not.', 'ride-sharing' ),
	                        )
	                    )
	                ) 
	            )
	        )
	    );
	}
}
add_action('init', 'ride_sharing_affiliate_vc_shortcodes');